/*--------------------------------------------------------------------------+
$Id$
|                                                                          |
| Copyright 2011 ForTISS GmbH                     |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.tooling.kernel.extension;

import org.fortiss.tooling.kernel.service.IExecutionService;

/**
 * An {@link IExecutionTarget} extension provides execution target like
 * simulators or code generators.
 * <P>
 * Execution targets are handled by {@link IExecutionService}.
 * 
 * @author hoelzl
 * @author $Author$
 * @version $Rev$
 * @ConQAT.Rating YELLOW Hash: E8CE87AEA96803C75F0EC8CB26892DB0
 */
public interface IExecutionTarget {

	/** Returns the name of the execution target. */
	String getName();

	/** Returns the class of the input, which can be executed by this target. */
	Class<? extends Object> getExecutableClass();

	/**
	 * Executes the given executable element. The provided element must be an
	 * instance of the class returned by {@link #getExecutableClass()}.
	 */
	Object execute(Object executable);
}
